/**
 * license: The MIT License, Copyright (c) 2012 YUKI "Piro" Hiroshi
 */

var TabBrowser = require('tab-browser');

exports.tabbarscroll = function(aCallback) {
  var listeners = [];

  new TabBrowser.Tracker({
    onTrack: function (aTabBrowser) {
      console.log('tabbarscroll: let\'s track '+aTabBrowser);
      var listener = {
            tabBrowser: aTabBrowser,
            target: aTabBrowser.tabContainer,
            callback: function(aEvent) {
              aCallback.call(aEvent.target, aTabBrowser, aEvent);
            },
            destroy: function() {
              this.target.removeEventListener('DOMMouseScroll',
                                              this.callback,
                                              true);
            }
          };
      listener.target.addEventListener('DOMMouseScroll',
                                       listener.callback,
                                       true);
      listeners.push(listener);
    },
    onUntrack: function(aTabBrowser) {
      console.log('tabbarscroll: let\'s untrack '+aTabBrowser);
      listeners.some(function(aListener, aIndex) {
        if (aListener.tabBrowser != aTabBrowser)
          return false;
        aListener.destroy();
        listeners.splice(aIndex, 1);
        return true;
      });
    }
  });

  require('unload').when(function(aEventType){
    if (aEventType == 'uninstall' ||
        aEventType == 'upgrade' ||
        aEventType == 'disable') {
      console.log('tabbarscroll: handle unloading by '+aEventType);
      listeners.forEach(function(aListener) {
        aListener.destroy();
      })
      listeners = [];
    }
  });
};